//
// Example of 
// - class with methods
// - using arrays
// - command line argument
// - reading a file
// - new for statement (see mean)
// - Array.sort
// - statistics
//

import java.io.*;
import java.util.*;

/** A data set of integers read from file
    @author Patrick Prosser
    @ version 1.0 */

public class DataSet {

    private int n;
    private int[] data;

    /** create a data set from file, where 1st entry in file is number of numbers in the file
	@param fname is the name of the file */

    public DataSet(String fname) throws IOException {
	Scanner sc = new Scanner(new File(fname));
	n = sc.nextInt();
	data = new int[n];
	for (int i=0;i<n;i++) data[i] = sc.nextInt();
    }

    public int mean(){
	int sum = 0;
	//for (int i=0;i<n;i++) sum = sum + data[i];
	for (int x : data) sum = sum + x;
	return sum/n;
    }

    public int median(){
	Arrays.sort(data);
	return data[n/2];
    }

    public int min(){
	int min = data[0];
	for (int i=1;i<n;i++) min = Math.min(min,data[i]);
	return min;
    }
    
    /** maximum in the data set */
    public int max(){
	int max = data[0];
	for (int i=1;i<n;i++) max = Math.max(max,data[i]);
	return max;
    }

    /** standard deviation */
    public double stDev(){
	int mean, sum, diff;
	mean = mean(); sum = diff = 0;
	for (int x : data){diff = x - mean; sum = sum + diff*diff;}
	return Math.sqrt((double)sum/(double)n);
    }

    /** gets file name from command line */
    public static void main(String[] args) throws IOException {

	DataSet x = new DataSet(args[0]);
	System.out.println("mean: "+ x.mean() +" min: "+ x.min() +" med: "+ x.median() 
			   +" max: "+ x.max() +" stDev: "+ x.stDev());
    }
}
